/**
 * Definici d'estructures pel servidor
 */

#define NOM_SERVIDOR "XicHttpd v0.1"

/* El format dels logs i el seu fitxer */
#define LOG_FORMAT "%s - [%s] \"%s\" \"%s\"\n"
FILE *f_log;

/* Estructura que representa la connexi d'un client */
typedef struct {
	pthread_t fil;				// El fil assignat a la connexi
	unsigned long int id;			// L'id
	int socket;				// El fd del socket
	struct sockaddr_in adreca_client;	// l'adrea del client
	time_t ctemps;				// Temps de creaci
	time_t atemps;				// Temps tlim accs
	c_request *dades;			// Capaleres client
} connexio;

/* Estructura que emmagatzema la configuraci del servidor */
typedef struct {
	char fitxer_config[255];
	char dir_base[255];
	char dir_cgi[255];
	char dir_html[255];
	char f_log[255];
	char f_err[255];
	char mime_types[255];
	char nom_host[64];
	short int port;
	struct sockaddr_in addr;
	int min_threads;
	int max_threads;
	time_t timeout;
} sconf;

/* El socket del servidor */
int server_sock;
/* El thread principal */
pthread_t pare;
/* La configuraci del servidor */
sconf config;
/* Punter a una taula de clients */
connexio *clients;
/* Punter a una taula de threads */
pthread_t *fils;
/* Punter a una taula de variables condicionals */
pthread_cond_t *cond;
/* Punter a una taula de variables mutex */
pthread_mutex_t *mutex;

/* Declaraci de funcions publiques */
void init(void);
void mata_thread (pthread_t fil, int cid);

